/*******************************************************************************
 * FoxItemCacheMail generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxItemCacheMail extends FoxItemCacheBase
    native;

var private array<MailMetaData> CachedItems;
var private bool bIsRefreshing;

function Cleanup()
{
    super.Cleanup();
    CachedItems.Length = 0;
    bIsRefreshing = false;
    //return;    
}

function SetupDelegates()
{
    // End:0x86
    if(NotEqual_InterfaceInterface(StoreInterface, (none)))
    {
        StoreInterface.AddQueryMailCompleteDelegate(0, QueryMailComplete);
        StoreInterface.AddMailNotificationDelegate(0, OnMailNotification);
    }
    //return;    
}

function CleanupDelegates()
{
    // End:0x86
    if(NotEqual_InterfaceInterface(StoreInterface, (none)))
    {
        StoreInterface.ClearQueryMailCompleteDelegate(0, QueryMailComplete);
        StoreInterface.ClearMailNotificationDelegate(0, OnMailNotification);
    }
    //return;    
}

protected function bool RefreshCache()
{
    // End:0x29
    if((IsDirty()) && !bIsRefreshing)
    {
        return ReadMail();
    }
    return true;
    //return ReturnValue;    
}

private final function bool ReadMail()
{
    bIsRefreshing = NotEqual_InterfaceInterface(StoreInterface, (none)) && StoreInterface.QueryMail();
    // End:0x6A
    if(!bIsRefreshing)
    {
        QueryMailComplete(0, "");
    }
    return bIsRefreshing;
    //return ReturnValue;    
}

function int GetNumMailItems()
{
    return CachedItems.Length;
    //return ReturnValue;    
}

function bool HasMail()
{
    return CachedItems.Length > 0;
    //return ReturnValue;    
}

function bool HasNewMail()
{
    local int I;

    I = 0;
    J0x0B:
    // End:0x60 [Loop If]
    if(I < CachedItems.Length)
    {
        // End:0x52
        if(CachedItems[I].bRead == false)
        {
            return true;
        }
        ++ I;
        // [Loop Continue]
        goto J0x0B;
    }
    return false;
    //return ReturnValue;    
}

function LocalMarkMailRead(string MailGuid)
{
    local int I;

    I = 0;
    J0x0B:
    // End:0x91 [Loop If]
    if(I < CachedItems.Length)
    {
        // End:0x83
        if(CachedItems[I].UniqueId == MailGuid)
        {
            CachedItems[I].bRead = true;
            // [Explicit Break]
            goto J0x91;
        }
        ++ I;
        J0x91:
        // [Loop Continue]
        goto J0x0B;
    }
    //return;    
}

function LocalMailOpened(string MailGuid)
{
    local int I;

    I = 0;
    J0x0B:
    // End:0xE1 [Loop If]
    if(I < CachedItems.Length)
    {
        // End:0xD3
        if(CachedItems[I].UniqueId == MailGuid)
        {
            CachedItems[I].Items.Length = 0;
            CachedItems[I].GPAmount = 0;
            CachedItems[I].ZPAmount = 0;
            // [Explicit Break]
            goto J0xE1;
        }
        ++ I;
        J0xE1:
        // [Loop Continue]
        goto J0x0B;
    }
    //return;    
}

function LocalMailDestroyed(string MailGuid)
{
    local int I;

    I = 0;
    J0x0B:
    // End:0x7D [Loop If]
    if(I < CachedItems.Length)
    {
        // End:0x6F
        if(CachedItems[I].UniqueId == MailGuid)
        {
            CachedItems.Remove(I, 1);
            // [Explicit Break]
            goto J0x7D;
        }
        ++ I;
        J0x7D:
        // [Loop Continue]
        goto J0x0B;
    }
    //return;    
}

function array<MailMetaData> GetMail()
{
    return CachedItems;
    //return ReturnValue;    
}

// Export UFoxItemCacheMail::execAppendMailItems(FFrame&, void* const)
private native final function AppendMailItems(string MailMetaData);

private final function QueryMailComplete(byte LocalUserNum, string MailData)
{
    // End:0x2F
    if(MailData != "")
    {
        AppendMailItems(MailData);
        bIsDirty = false;
    }
    bIsRefreshing = false;
    //return;    
}

private final function OnMailNotification(string MailData)
{
    AppendMailItems(MailData);
    //return;    
}
